﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports Microsoft.Win32

Namespace AddinLoadingOnCondition
    'Add-in Express Add-in Module
    <GuidAttribute("E2D2C8C3-EF80-474C-8182-D70B708ABA4B"), ProgIdAttribute("AddinLoadingOnCondition-vb.AddinModule")> _
    Public Class AddinModule
        Inherits AddinExpress.MSO.ADXAddinModule

        Friend WithEvents TestCommandBar As AddinExpress.MSO.ADXCommandBar
        Friend WithEvents AdxRibbonTab1 As AddinExpress.MSO.ADXRibbonTab
        Friend WithEvents AdxCommandBarButton2 As AddinExpress.MSO.ADXCommandBarButton
        Friend WithEvents AdxRibbonGroup1 As AddinExpress.MSO.ADXRibbonGroup
        Friend WithEvents AdxRibbonButton1 As AddinExpress.MSO.ADXRibbonButton

        Private Const WillLoad As Integer = 0
        Private Const WillNotLoad As Integer = 1

#Region " Component Designer generated code. "
        'Required by designer
        Private components As System.ComponentModel.IContainer

        'Required by designer - do not modify
        'the following method
        Private Sub InitializeComponent()
            Me.components = New System.ComponentModel.Container
            Me.TestCommandBar = New AddinExpress.MSO.ADXCommandBar(Me.components)
            Me.AdxCommandBarButton2 = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
            Me.AdxRibbonTab1 = New AddinExpress.MSO.ADXRibbonTab(Me.components)
            Me.AdxRibbonGroup1 = New AddinExpress.MSO.ADXRibbonGroup(Me.components)
            Me.AdxRibbonButton1 = New AddinExpress.MSO.ADXRibbonButton(Me.components)
            '
            'TestCommandBar
            '
            Me.TestCommandBar.CommandBarName = "Test CommandBar"
            Me.TestCommandBar.CommandBarTag = "75b2b373-f17b-4376-9676-209ca3249661"
            Me.TestCommandBar.Controls.Add(Me.AdxCommandBarButton2)
            Me.TestCommandBar.UpdateCounter = 3
            '
            'AdxCommandBarButton2
            '
            Me.AdxCommandBarButton2.Caption = "NOT Load add-in at next startup"
            Me.AdxCommandBarButton2.ControlTag = "a2616fe8-4ab0-4eb2-9942-d8a6e121305a"
            Me.AdxCommandBarButton2.ImageTransparentColor = System.Drawing.Color.Transparent
            Me.AdxCommandBarButton2.UpdateCounter = 4
            '
            'AdxRibbonTab1
            '
            Me.AdxRibbonTab1.Caption = "Add-in Express ltd."
            Me.AdxRibbonTab1.Controls.Add(Me.AdxRibbonGroup1)
            Me.AdxRibbonTab1.Id = "adxRibbonTab_97c2d4409ae84e5387675c0c8da1d898"
            Me.AdxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
            '
            'AdxRibbonGroup1
            '
            Me.AdxRibbonGroup1.Caption = "Sample"
            Me.AdxRibbonGroup1.Controls.Add(Me.AdxRibbonButton1)
            Me.AdxRibbonGroup1.Id = "adxRibbonGroup_e3fd5a48d3b04b219464cb8e632acf0a"
            Me.AdxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent
            Me.AdxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
            '
            'AdxRibbonButton1
            '
            Me.AdxRibbonButton1.Caption = "NOT Load add-in at next startup"
            Me.AdxRibbonButton1.Id = "adxRibbonButton_bf0b19a1ebb643c49c7950450b4336af"
            Me.AdxRibbonButton1.ImageTransparentColor = System.Drawing.Color.Transparent
            Me.AdxRibbonButton1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
            '
            'AddinModule
            '
            Me.AddinName = "AddinLoadingOnCondition-vb"
            Me.Description = "Demonstrates how to disable/enable add-in's functionality and UI on condition."
            Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel

        End Sub

#End Region

#Region " Add-in Express automatic code "

        'Required by Add-in Express - do not modify
        'the methods within this region

        Public Overrides Function GetContainer() As System.ComponentModel.IContainer
            If components Is Nothing Then
                components = New System.ComponentModel.Container
            End If
            GetContainer = components
        End Function

        <ComRegisterFunctionAttribute()> _
        Public Shared Sub AddinRegister(ByVal t As Type)
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
        End Sub

        <ComUnregisterFunctionAttribute()> _
        Public Shared Sub AddinUnregister(ByVal t As Type)
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
        End Sub

        Public Overrides Sub UninstallControls()
            MyBase.UninstallControls()
        End Sub

#End Region

        Public Sub New()
            MyBase.New()

            Application.EnableVisualStyles()
            'This call is required by the Component Designer
            InitializeComponent()

            'Please add any initialization code to the AddinInitialize event handler

        End Sub

        Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
            Get
                Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
            End Get
        End Property

        Public ReadOnly Property ExcelApp() As Excel._Application
            Get
                Return CType(HostApplication, Excel._Application)
            End Get
        End Property


        Private Sub AdxCommandBarButton2_Click(ByVal sender As System.Object) Handles AdxCommandBarButton2.Click
            Dim keyValue As String = "HKEY_CURRENT_USER\" & Me.RegistryKey
            Dim startAddIn As Integer = CInt(Fix(Registry.GetValue(keyValue, "LoadAddIn", WillLoad)))
            If startAddIn = WillLoad Then
                Registry.SetValue(keyValue, "LoadAddIn", WillNotLoad)
                AdxCommandBarButton2.Caption = "Load add-in at next startup"
            Else
                Registry.SetValue(keyValue, "LoadAddIn", WillLoad)
                AdxCommandBarButton2.Caption = "NOT Load add-in at next startup"
            End If
        End Sub

        Private Sub AddinModule_AddinInitialize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.AddinInitialize
            Dim keyValue As String = "HKEY_CURRENT_USER\" & Me.RegistryKey
            Dim startAddIn As Integer = CInt(Fix(Registry.GetValue(keyValue, "LoadAddIn", WillLoad)))
            If startAddIn = WillNotLoad Then
                RemoveComponents()
                Registry.SetValue(keyValue, "LoadAddIn", WillLoad)
            End If
        End Sub

        Private Sub AdxRibbonButton1_OnClick(ByVal sender As System.Object, ByVal control As AddinExpress.MSO.IRibbonControl, ByVal pressed As System.Boolean) Handles AdxRibbonButton1.OnClick
            Dim keyValue As String = "HKEY_CURRENT_USER\" & Me.RegistryKey
            Dim startAddIn As Integer = CInt(Fix(Registry.GetValue(keyValue, "LoadAddIn", WillLoad)))
            If startAddIn = WillLoad Then
                Registry.SetValue(keyValue, "LoadAddIn", WillNotLoad)
                AdxRibbonButton1.Caption = "Load add-in at next startup"
            Else
                Registry.SetValue(keyValue, "LoadAddIn", WillLoad)
                AdxRibbonButton1.Caption = "NOT Load add-in at next startup"
            End If
        End Sub

        Private Sub AddinModule_OnRibbonBeforeCreate(ByVal sender As System.Object, ByVal ribbonId As System.String) Handles MyBase.OnRibbonBeforeCreate
            Dim keyValue As String = "HKEY_CURRENT_USER\" & Me.RegistryKey
            Dim startAddIn As Integer = CInt(Fix(Registry.GetValue(keyValue, "LoadAddIn", WillLoad)))
            If startAddIn = WillNotLoad Then
                RemoveComponents()
                Registry.SetValue(keyValue, "LoadAddIn", WillLoad)
            End If
        End Sub

        Private Sub RemoveComponents()
            For i As Integer = Me.components.Components.Count - 1 To 0 Step -1
                Me.components.Remove(Me.components.Components(i))
            Next i
        End Sub

    End Class

End Namespace
